/******************************* Copyright notice *******************************
Copyright (C)2002 by Andrei Loskutov <loskutov@gmx.de>. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
********************************************************************************/

/**
 * Created on 02.12.2002
 *
 * To change this generated comment edit the template variable "filecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of file comments go to
 * Window>Preferences>Java>Code Generation.
 */
package adiag.gui;

import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import adiag.connection.Configuration;
import adiag.connection.PropertySetter;
import adiag.model.Const;

/**
 * @author Andy the Great
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
/**
 * Panel to show/set options
 * @author Andy the Great
 */
public class PropertiesPanel extends JPanel {

    /** table, key is option, value is textbox */
    HashMap text_map = new HashMap();
    Configuration conf;
    /**
     * Constructor for PropertiesPanel.
     */
    public PropertiesPanel(Configuration app) {
        super();
        conf = app;
        PropertySetter setter = app.getPropsSetter();
        ArrayList keys = setter.getKeyList(app);
        this.setLayout(new GridLayout(keys.size(), 2, 3, 3));
        String key, value;
        JTextField t;
        JLabel l;
        for (int i = 0; i < keys.size(); i++) {
            key = "" + keys.get(i);
            value = "" + app.getProperty(key);
            if(Const.PROPERTY_P4_PASSWD.equals(key)){
                t = new JPasswordField(value); 
            } else {
                t = new JTextField(value);
            }
            t.setName(key);
            text_map.put(key, t);
            l = new JLabel(key);
            l.setName(key);
            this.add(l);
            this.add(t);
        }
    }

    /**
     * set properties for application
     */
    public void setProps() {
        PropertySetter setter = conf.getPropsSetter();
        ArrayList keys = setter.getKeyList(conf);
        String key, value;
        for (int i = 0; i < keys.size(); i++) {
            key = "" + keys.get(i);
            value = "" + ((JTextField) text_map.get(key)).getText().trim();
            if (!conf.getProperty(key).trim().equals(value)) {
                setter.setProperty(key, value, conf);
            }
        }
    }

    /**
     * Set values in this panel from current values from application
     */
    public void reset() {
        JTextField t;
        ArrayList alist = new ArrayList(text_map.keySet());
        for (int i = 0; i < alist.size(); i++) {
            t = (JTextField) text_map.get(alist.get(i));
            t.setText(conf.getProperty(t.getName()));
        }
    }
}
